include \masm32\include\masm32rt.inc
include Shift64.inc		; contains the shl64 and shr64 macros

	ToutEnMasm	= 1		;  [url=http://www.masm32.com/board/index.php?topic=11634.msg87871#msg87871]ToutEnMasm proposal[/url]

m2mq MACRO dest, src
		push dword ptr src
		push dword ptr src[4]
		pop dword ptr dest[4]
		pop dword ptr dest
ENDM

.data
MyQw1s	dq 1234567812345678h
MyQw2s	dq 0ffffffffffffffffh

.data?
MyQw1	dq ?
MyQw2	dq ?
MyQwRes	dq ?

.code
start:
			m2mq MyQw1, MyQw1s		; reload MyQw1 = 1234567812345678h
			m2mq MyQw2, MyQw2s		; reload MyQw2 = 0ffffffffffffffffh

	shl64 MyQw1, 3		; qword, immediate counter

	mov ecx, 3
	shl64 MyQw1, cl		; qword, reg8 counter

	mov edx, offset MyQw1	; ptr to src in edx
	shl64 edx, 3		; ptr, reg8 counter

	mov eax, offset MyQw1	; ptr to src in eax
	mov ecx, 3
	shl64 eax, cl		; ptr, reg8 counter

	shl64 MyQw1, 3, MyQwRes	; result to MyQwRes

	mov eax, offset MyQw1	; ptr to src in eax
	mov ecx, 3
	shl64 eax, cl, MyQwRes	; result to MyQwRes

	shiftLeft		= 0
	shiftRight	= 0
	print "Testing qword shift macros:", 13, 10
	REPEAT 7
		shiftLeft		= shiftLeft + 8
		shiftRight	= shiftRight + 8
		NumberOfShifts = shiftLeft
		VarCt = 0
		print chr$(13, 10)

		REPEAT 2-ToutEnMasm
			m2mq MyQw1, MyQw1s		; reload MyQw1 = 1234567812345678h
			m2mq MyQw2, MyQw2s		; reload MyQw2 = 0ffffffffffffffffh
			VarCt = VarCt + 1
			tmp$ CATSTR <print qwhex$(MyQw>, %VarCt, <),"  original value", 13, 10>
			tmp$
			if ToutEnMasm
			tmp$ CATSTR <shr64 MyQw>, %VarCt, <, >, %shiftRight, <, MyQwRes>	; pass qword and immediate shift count
			tmp$
			tmp$ CATSTR <print qwhex$(MyQwRes>, <), "  shr64 MyQw>, %VarCt, <, >, %shiftRight, <, MyQwRes", 13, 10>
			tmp$
   ; [url=http://www.masm32.com/board/index.php?topic=11634.msg87871#msg87871]ToutEnMasm proposal[/url]
   m2mq MyQw1, MyQw1s		; reload MyQw1 = 1234567812345678h

   mov eax, NumberOfShifts
   push eax
   fild dword ptr [esp]   
   pop eax
   fld1   
   fscale
   fild qword ptr MyQw1
   fdiv st(0),st(1)
   fistp qword ptr MyQwRes
   fstp st
   fstp st

   print qwhex$(MyQwRes), "  fpu, ToutEnMasm", 13, 10
   else
			tmp$ CATSTR <shl64 MyQw>, %VarCt, <, >, %shiftLeft	; pass qword and immediate shift count
			tmp$
			tmp$ CATSTR <print qwhex$(MyQw>, %VarCt, <), "  shl64 MyQw>, %VarCt, <, >, %shiftLeft, <", 13, 10>
			tmp$
			tmp$ CATSTR <shr64 MyQw>, %VarCt, <, >, %shiftRight, <, MyQwRes>	; pass qword and immediate shift count
			tmp$
			tmp$ CATSTR <print qwhex$(MyQwRes>, <), "  shr64 MyQw>, %VarCt, <, >, %shiftRight, <, MyQwRes", 13, 10>
			tmp$
   endif
		ENDM
	ENDM

	print chr$(13, 10, "Code sizes:", 13, 10, "fpu", 9)
	mov eax, TeM_end
	sub eax, TeM_start
	print str$(eax), 13, 10, "alu", 9
	mov eax, shr64_end
	sub eax, shr64_start
	print str$(eax), 13, 10	

	getkey
	exit				; short form of invoke ExitProcess, 0

	shr64_start:
	shr64 MyQw1, 40
	shr64_end:
	
	
TeM_start:
   mov eax, NumberOfShifts
   push eax
   fild dword ptr [esp]   
   pop eax
   fld1   
   fscale
   fild qword ptr MyQw1
   fdiv st(0),st(1)
   fistp qword ptr MyQwRes
   fstp st
   fstp st

TeM_end:
	
end start

RichMasm options:
OxPT_Linker	link	; If present in \bin, PoLink.exe will be used by default; delete the x to force link.exe
OxPT_Assembler	JWasm	; If present in \bin, JWasm.exe may be used: just delete the x 
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_NoWarn	LNK4254, multiple	; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OPT_WAIT	0		; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
